var argArray = new Array;

function remCookie(serviceHost) {
var cmgr = Components.classes["@mozilla.org/cookiemanager;1"].getService();
cmgr = cmgr.QueryInterface(Components.interfaces.nsICookieManager);
var cookies = cmgr.enumerator;
while (cookies.hasMoreElements()){
	var cookie = cookies.getNext();
		if (cookie instanceof Components.interfaces.nsICookie){
	      if (cookie.host.substr(cookie.host.indexOf(serviceHost)) != -1) {
			if (cookie.expires == 0) { cmgr.remove(cookie.host, cookie.name, cookie.path, false); }}}}
}
function PromptForNewPassWord(hostName) {
 	var results = new Array;
	results['user'] = null;
	results['pass'] = null;
	var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	username = {value:""}; password = {value:""}; check = {value:true};
	while (username.value == "" || password.value == "") MsgBox = prompts.promptUsernameAndPassword(window, 'Store A New Password: ' + hostName, 'The extension could not find your credentials!', username, password, 'Save to Password Manager?', check);
	if (MsgBox) {
		if (check.value) StoreNewPassword(hostName, username.value, password.value);
		results['user'] = username.value;
		results['pass'] = password.value; }
	return results;
}
function RemovePassword(hostName, username, password) {
	var chkPasswordManager = Components.classes["@mozilla.org/passwordmanager;1"];
	var chkLoginManager = Components.classes["@mozilla.org/login-manager;1"];
	     
	if (chkPasswordManager != null) {
		var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);
		passwordManager.removeUser(hostName, username);
	}
	else if (chkLoginManager != null) {
		var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
		var logins = passwordManager.getAllLogins({});
			for (var i = 0; i < logins.length; i++) {
				if (logins[i].hostname == hostName && logins[i].username == username && logins[i].password == password) {
				         passwordManager.removeLogin(logins[i]); break; }
				}		
	}
}
function StoreNewPassword(hostName, username, password) {
	var chkPasswordManager = Components.classes["@mozilla.org/passwordmanager;1"];
	var chkLoginManager = Components.classes["@mozilla.org/login-manager;1"];
		 
	if (chkPasswordManager != null) {
		var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);
		passwordManager.addUser(hostName, username, password);
	}
	else if (chkLoginManager != null) {
		var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
		var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1", Components.interfaces.nsILoginInfo, "init");
		var loginInfo = new nsLoginInfo(hostName, hostName, null, username, password, null, null);
		passwordManager.addLogin(loginInfo);
	}
}
function getPasswordFromManager(queryString){
	var chkPasswordManager = Components.classes["@mozilla.org/passwordmanager;1"];
	var chkLoginManager = Components.classes["@mozilla.org/login-manager;1"];
	var results = new Array; var accountsU = new Array; var accountsP = new Array;
	results['user'] = null; results['pass'] = null;
	
	if (chkPasswordManager != null) {
	var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);
	var e = passwordManager.enumerator;
				while (e.hasMoreElements()) {
					try {
								var pass = e.getNext().QueryInterface(Components.interfaces.nsIPassword);
								if (pass.host == queryString) {accountsU.push(pass.user); accountsP.push(pass.password);}
							} catch (ex) {}}}
	else if (chkLoginManager != null) {
		var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
		var logins = passwordManager.getAllLogins({});
			for (var i = 0; i < logins.length; i++) {
				if (logins[i].hostname == queryString) {
					accountsU.push(logins[i].username); accountsP.push(logins[i].password);}
				}}
				if (accountsU.length > 1) {
					var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
					var selected = {};
					var ok = prompts.select(window, "Multiple Accounts Found!", "Please choose account from the following list:", accountsU.length, accountsU, selected);
					if (ok) {
						results['user'] = accountsU[selected.value];
						results['pass'] = accountsP[selected.value];} else {
						results['user'] = null;
						results['pass'] = "cancelled";}
				} else {
				results['user'] = accountsU[0];
				results['pass'] = accountsP[0];}				
				
				return results;
}
function GenerateComposeWindow(CookieHost, PMHost, PMHost2, cma, to, subject, cc, bcc, body, extra, DataToSend, WhereToSend, urlencoded, testmode, altAccount) {
	remCookie(CookieHost);  //remove all end-of-session expiring cookie
	var results = new Array;	//create & clear user&pass array
	if (!altAccount) { results = getPasswordFromManager(PMHost);	//get u&p from PM (PMHost)
	if (results['user'] == null && results['pass'] == null && PMHost2 != null) results = getPasswordFromManager(PMHost2); //if nothing was found (and PMHost2 was supllied), try PMHost2
	if (results['user'] == null && results['pass'] == null) results = PromptForNewPassWord(PMHost); } //if still nothing is found, prompt for username & password 
	if (results['user'] != null || altAccount) { //given that the user hit OK (as opposed to cancel) at the prompt
		
	DataToSend = DataToSend.replace("{{user}}", results['user']);
	DataToSend = DataToSend.replace("{{pass}}", results['pass']);
	DataToSend = DataToSend.replace("{{usrd}}", ParseAOLsUSRD());	//AOL-specific issue
	
	var addr = cma + to + argArray['to'] + subject + argArray['subject'] + cc + argArray['cc'] + bcc + argArray['bcc'] + body + argArray['body'] + extra;
	CreateSession(DataToSend, WhereToSend, urlencoded, CookieHost, addr, testmode); }
}
function CreateSession(DataToSend, WhereToSend, urlencoded, CookieHost, addr, testmode) {
	xmlhttp = new XMLHttpRequest();	
	xmlhttp.onreadystatechange = function() { HandleXMLHTTPResponse(xmlhttp, CookieHost, addr, testmode); };
	xmlhttp.open("POST", WhereToSend, true);
	if (urlencoded) xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded"); 
	xmlhttp.send(DataToSend);
}
function HandleXMLHTTPResponse(xmlhttp, CookieHost, addr, testmode){
var FM_UST = "";
if (xmlhttp.readyState == 4) {
 if (xmlhttp.status == 200) {
	if (CookieHost == "aol.com") {	//AOL-specific issue
		var ParseRedirect = xmlhttp.responseText.substr(xmlhttp.responseText.indexOf('<body onLoad='));
		ParseRedirect = ParseRedirect.substr(ParseRedirect.indexOf('http://'));
		ParseRedirect = ParseRedirect.substring(0, ParseRedirect.indexOf(');') - 1);
		xmlhttp.open('GET', ParseRedirect, false);
		xmlhttp.send(null); }
	
	if (CookieHost == "fastmail.fm") {	//Fastmail.FM-specific issue
		var ParseRedirect = xmlhttp.responseText.substr(xmlhttp.responseText.indexOf('&Ust=') + 5);
		FM_UST = ParseRedirect.substring(0, ParseRedirect.indexOf('&'));
		addr += "&Ust=" + FM_UST + "&UDm=49"; }
	
	getBrowser().selectedTab = getBrowser().addTab(addr);
} else { alert("Credentials Error") }}
if (testmode) { getBrowser().selectedTab = getBrowser().addTab(""); content.document.write(xmlhttp.responseText); }
}
function WallaMail() {
	remCookie("walla.com");
	var results = new Array();
	results = getPasswordFromManager('http://friends.walla.com');
	if (results['user'] == null) { results = StoreNewPassword("http://friends.walla.com"); }
	
	var addr = "";
	addr = "http://mail.walla.com/?w=/@compose";
	addr += "&to=" + argArray['to'];
	addr += "&subject=" + argArray['subject'];
	addr += "&cc=" + argArray['cc'];
	addr += "&bcc=" + argArray['bcc'];
	addr += "&body=" + argArray['body'];	//notworking

	xmlhttp = new XMLHttpRequest();
	var DataToSend = "w=/@login.commit&username=" + results['user'] + "&password=" + results['pass'];
	xmlhttp.open('POST', 'http://friends.walla.com/', false);
	xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded"); 
	xmlhttp.send(DataToSend);
	getBrowser().selectedTab = getBrowser().addTab("http://walla.com");	
}
function Init(evt) {
	var contextMenu = document.getElementById("contentAreaContextMenu"); 
	window.removeEventListener("load", Init, true);
    getBrowser().addEventListener("mousedown", handleMouseDown, true);
    getBrowser().addEventListener("mouseup", captureClicks, true);
    getBrowser().addEventListener("click", captureClicks, true);	
 
	if (contextMenu) contextMenu.addEventListener("popupshowing", showHideContextItems, false);
}
function ParseMailTo(href) {		
		var link = href.substr(href.indexOf(':') + 1);
		
		if (link.indexOf('?') != -1) {
		var to = link.substr(0, link.indexOf('?'));
		var arguments = link.substr(link.indexOf('?') + 1);
		argArray = arguments.split('&');
		argArray['to'] = to;
		
		for (var i = 0; i < argArray.length; i++) {
			if (argArray[i].substr(0,3).toLowerCase() == "cc=") argArray['cc'] = argArray[i].substr(3);
			if (argArray[i].substr(0,4).toLowerCase() == "bcc=") argArray['bcc'] = argArray[i].substr(4);
			if (argArray[i].substr(0,5).toLowerCase() == "body=") argArray['body'] = argArray[i].substr(5);
			if (argArray[i].substr(0,8).toLowerCase() == "subject=") argArray['subject'] = argArray[i].substr(8);
		}} else { 
		argArray['to'] = link; argArray['cc'] = ""; argArray['bcc'] = ""; 
		argArray['subject'] = ""; argArray['body'] = ""; }
		
		return;
}
function ParseAOLsUSRD(){
	xmlhttp = new XMLHttpRequest();
	xmlhttp.open('GET', 'https://my.screenname.aol.com/_cqr/login/login.psp?mcState=initialized&sitedomain=sns.webmail.aol.com', false);
	xmlhttp.send(null);

	ParseUSRD = xmlhttp.responseText.substr(xmlhttp.responseText.indexOf('usrd'));
	ParseUSRD = ParseUSRD.substr(ParseUSRD.indexOf('value="') + 7);
	ParseUSRD = ParseUSRD.substring(0, ParseUSRD.indexOf('"'));

	return ParseUSRD;
}
function handleMouseDown(evt) {
	var lclick = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBoolPref("extensions.mail2web.chkleftclick");	
		
	if (lclick && evt.button == 0) {
		var link_type = null;
		var href = evt.originalTarget.getAttribute("href");
	    link_type = href.substring(0, href.indexOf(':')).toLowerCase();

		if (link_type == "mailto") {
			evt.stopPropagation();
			evt.preventDefault();
			ParseMailTo(href);
			LaunchDefaultService();
			}
	}
}
function captureClicks(evt) {
	var lclick = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBoolPref("extensions.mail2web.chkleftclick");

	if (lclick && evt.button == 0) {
	    var link_type = null;
		var href = evt.originalTarget.getAttribute("href");
	    link_type = href.substring(0, href.indexOf(':')).toLowerCase();
		if (link_type == "mailto") {
			evt.stopPropagation();
			evt.preventDefault();
			return false;
		}
	}
}
function acntAction(action) {
	if (action == "add") {
		username = document.getElementById('username').value;
		password = document.getElementById('password').value;
		service = document.getElementById('WebService').value;

		if (username != "" && password != "") {
		StoreNewPassword(service, username, password);		
		var serviceName = opener.opener.Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getCharPref(service + "|name");
		var serviceIcon = opener.opener.Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getCharPref(service + "|icon");
		listbox = opener.document.getElementById('thelist');
		listitem = listbox.appendItem(serviceName + " (" + username.substr(0,5) +"...)", service + "|" + username + "|" + password);
		listitem.setAttribute("class", "listitem-iconic");
		listitem.setAttribute("image", "chrome://mail2web/skin/" + serviceIcon);

		} else { alert("Invalid Username and/or Password!"); return false; }}
	if (action == "edit") {
		username = document.getElementById('username').value;
		password = document.getElementById('password').value;
		webservice = document.getElementById('WebService').value;
		oldusername = window.arguments[0].inn.oldusername;
		oldpassword = window.arguments[0].inn.oldpassword;
		oldservice = window.arguments[0].inn.oldWebService;
	
		if (username != "" && password != "") {
			//remove old password from manager - then add new one
			listbox = opener.document.getElementById('thelist');
			listbox.removeItemAt(window.arguments[0].inn.oldindex);
			RemovePassword(oldservice, oldusername, oldpassword);
			StoreNewPassword(webservice, username, password);
			
			// add to list
			var serviceName = opener.opener.Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getCharPref(webservice + "|name");
			var serviceIcon = opener.opener.Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getCharPref(webservice + "|icon");
			listitem = listbox.appendItem(serviceName + " (" + username.substr(0,5) +"...)", webservice + "|" + username + "|" + password);
			listitem.setAttribute("class", "listitem-iconic");
			listitem.setAttribute("image", "chrome://mail2web/skin/" + serviceIcon);
			
			} else { alert("Invalid Username and/or Password!"); return false; }}
	if (action == "remove") {
		var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
		var confirmDlg = prompts.confirm(window, "Remove Account", "Are you sure you wish to remove this account?");
		if (confirmDlg) {
			var oldAccount = document.getElementById('thelist').value.split("|");		
			RemovePassword(oldAccount[0], oldAccount[1], oldAccount[2]);
			listbox = document.getElementById('thelist');
			listbox.removeItemAt(listbox.selectedIndex);
		}}
}
function appendToList(serviceHost, user, pass) {	
	listbox = document.getElementById('thelist');	 
	try {
		var serviceName = opener.Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getCharPref(serviceHost + "|name");
		var serviceIcon = opener.Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getCharPref(serviceHost + "|icon");
		listitem = listbox.appendItem(serviceName + " (" + user.substr(0,5) +"...)", serviceHost + "|" + user + "|" + pass);
		listitem.setAttribute("class", "listitem-iconic");
		listitem.setAttribute("image", "chrome://mail2web/skin/" + serviceIcon);
	} catch (ex) {}
}
function loadDialog(frmDialog){
	if (frmDialog == "onLoadManager") {
	var chkPasswordManager = Components.classes["@mozilla.org/passwordmanager;1"];
	var chkLoginManager = Components.classes["@mozilla.org/login-manager;1"];

	if (chkPasswordManager != null) {
	var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);
	var e = passwordManager.enumerator;
				while (e.hasMoreElements()) {
					try {
						        var pass = e.getNext().QueryInterface(Components.interfaces.nsIPassword);
								appendToList(pass.host, pass.user, pass.password);
								} catch (ex) {}}}
	else if (chkLoginManager != null) {
		var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
		var logins = passwordManager.getAllLogins({});
			for (var i = 0; i < logins.length; i++) {
				appendToList(logins[i].hostname, logins[i].username, logins[i].password); }}
	}

	if (frmDialog == "onLoadEdit") {
	document.getElementById("username").value = window.arguments[0].inn.username;
	document.getElementById("password").value = window.arguments[0].inn.password;
	document.getElementById("WebService").value = window.arguments[0].inn.WebService; }
	
	if (frmDialog == "launchEdit") {
		var oldAccount = document.getElementById('thelist').value.split("|");
		var params = {inn:{oldusername:oldAccount[1], oldpassword:oldAccount[2], oldWebService:oldAccount[0], username:oldAccount[1], password:oldAccount[2], WebService:oldAccount[0], oldindex:document.getElementById('thelist').selectedIndex}, out:null}; 
		window.openDialog("chrome://mail2web/content/editacnt.xul", "","chrome, dialog, modal, resizable=yes", params).focus(); }
}
function LaunchService(serviceHost, altAccount) {
	var valUser = "{{user}}";
	var valPass = "{{pass}}";

	if (altAccount) {
	var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var hosts = ["Yahoo Mail", "GMail", "Fastmail.FM", "Mail.Com (Normal)", "Mail.Com (Beta)", "AOL Mail (Basic)", "AOL Mail (Standard)", "Opera Mail", "Lycos Mail"];
	var hostname = ["https://login.yahoo.com", "https://www.google.com", "http://fastmail.fm", "http://www.mail.com", "http://www.mail.com", "https://my.screenname.aol.com", "https://my.screenname.aol.com", "http://www.operamail.com", "http://mail.lycos.com"];
	var hostservice = ["yahoo", "gmail", "fastmail", "normal.mail.com", "beta.mail.com", "basic.aol", "standard.aol", "operamail", "lycos"];
	var selected = {};
	var ok = prompts.select(window, "Web2:Mail Alternative Account", "Please Select Webservice:", hosts.length, hosts, selected);
	if (ok) {
		username = {value:""}; password = {value:""}; check = {value:false};
		userpass = prompts.promptUsernameAndPassword(window, 'Web2:Mail Alternative Account', 'Please Enter Username & Password:', username, password, 'Save to Password Manager?', check);
		if (userpass) {
			valUser = username.value; valPass = password.value; serviceHost = hostservice[selected.value];
			if (check.value) StoreNewPassword(hostname[selected.value], username.value, password.value);
			} ParseMailTo(gContextMenu.target.toString()); }}
		
	if (serviceHost == "yahoo")	GenerateComposeWindow("yahoo.com", "https://login.yahoo.com", null, "http://compose.mail.yahoo.com/?", "To=", "&Subj=", "&Cc=", "&Bcc=", "&Body=", "", "login=" + valUser + "&passwd=" + valPass, "https://login.yahoo.com/config/login?", false, false, altAccount);
	if (serviceHost == "gmail") GenerateComposeWindow("google.com", "https://www.google.com", null, "https://mail.google.com/mail?view=cm&fs=1", "&to=", "&su=", "&cc=", "&bcc=", "&body=", "", "Email=" + valUser + "&Passwd=" + valPass + "&service=mail", "https://www.google.com/accounts/ServiceLoginAuth?service=mail", true, false, altAccount);
	if (serviceHost == "normal.mail.com") GenerateComposeWindow("mail.com", "http://www.mail.com", null, "http://mail01.mail.com/scripts/mail/Outblaze.mail?", "composeto=", "&subject=", "&cc=", "&bcc=", "&body=", "&compose=1", "login=" + valUser + "&password=" + valPass + "&siteselected=normal", "http://www2.mail.com/scripts/common/proxy.main?signin=1", true, false, altAccount);
	if (serviceHost == "beta.mail.com") GenerateComposeWindow("mail.com", "http://www.mail.com", null, "http://beta01.mail.com/scripts/mail/Outblaze.mail?", "composeto=", "&subject=", "&cc=", "&bcc=", "&body=", "&compose=1", "login=" + valUser + "&password=" + valPass + "&siteselected=betaus", "http://www2.mail.com/scripts/common/proxy.main?signin=1", true, false, altAccount);
	if (serviceHost == "lycos") GenerateComposeWindow("lycos.com", "http://mail.lycos.com", null, "http://mail.lycos.com/lycos/mail/MailComposeFrame.lycos?", "TO=", "&SUBJECT=", "&CC=", "&BCC=", "&BODY=", "", "m_U=" + valUser + "&m_P=" + valPass, "https://registration.lycos.com/login.php?m_PR=27", true, false, altAccount);
	if (serviceHost == "operamail") GenerateComposeWindow("operamail.com", "http://www.operamail.com", null, "http://mymail.operamail.com/scripts/mail/Outblaze.mail?compose=1&did=1&a=1&", "to=", "&subject=", "&cc=", "&bcc=", "&body=", "", "action=login&domain=operamail.com&login=" + valUser + "&password=" + valPass, "http://www.operamail.com/scripts/common/proxy.main", true, false, altAccount);
	if (serviceHost == "fastmail") GenerateComposeWindow("fastmail.fm", "http://www.fastmail.fm", "http://fastmail.fm", "https://www.fastmail.fm/mail/?MSignal=", "MC-FromName**", "%3fsubject=", "%26cc=", "%26bcc=", "%26body=", "", "FLN-UserName=" + valUser + "&FLN-Password=" + valPass, "http://www.fastmail.fm/mail/?UDm=49", true, false, altAccount);
	if (serviceHost == "basic.aol") GenerateComposeWindow("aol.com", "https://my.screenname.aol.com", null, "http://webmail.aol.com/aol/Lite/Compose.aspx?", "to=", "&subject=", "&cc=", "&bcc=", "&RichBody=", "", "mcState=initialized&usrd={{usrd}}&loginId=" + valUser + "&password=" + valPass, "https://my.screenname.aol.com/_cqr/login/login.psp", true, false, altAccount);
	if (serviceHost == "standard.aol") GenerateComposeWindow("aol.com", "https://my.screenname.aol.com", null, "http://webmail.aol.com/aol/Mail/ComposeMessage.aspx?", "to=", "&subject=", "&cc=", "&bcc=", "&body=", "", "mcState=initialized&usrd={{usrd}}&loginId=" + valUser + "&password=" + valPass, "https://my.screenname.aol.com/_cqr/login/login.psp", true, false, altAccount);
}
function LaunchDefaultService() {
	var serviceHost = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getCharPref("extensions.mail2web.servicehost");
	LaunchService(serviceHost, false);
	}
function showHideContextItems(event){
	var ctxtMenuManifest = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBoolPref("extensions.mail2web.chkcontextmenu");;
	var m2o = document.getElementById("mail2web:Other");
	var m2d = document.getElementById("mail2web:Default");
	var m2a = document.getElementById("mail2web:Alternate");
	var sep = document.getElementById("M2:Sep");
	
	if (gContextMenu.onMailtoLink && ctxtMenuManifest) {
	m2o.hidden = false; m2d.hidden = false; sep.hidden = false; m2a.hidden = false;
	} else { m2o.hidden = true; m2d.hidden = true; sep.hidden = true; m2a.hidden = true; }
}

window.addEventListener("load", Init, true);